<?php include('visitor.php'); new visitor_adm(); class visitor_adm {
/*===========================================================================
Visitor info and logging admin script for PHP 5+.
© Andrew Revvo, 2012, http://atrise.com/php/visitor/
License: http://atrise.com/we/license/

  *******************************************************
  *** This is a demo version. Not for production use! ***
  *******************************************************

============================================================================*/
// Settings

	// Admin password
	static $admin_password = 'demo';

	// Admin page compression level
	// 		0(disable), -1(php default), 1(low compression), ... ,9(best)
	static $admin_gzip = -1;
	
/*===========================================================================*/

	function __construct()
	{
		if (realpath($_SERVER['SCRIPT_FILENAME']) == realpath(__FILE__))
			self::dispatch();
	}

	static function dispatch()
	{
		header('Cache-Control: no-cache, must-revalidate');
		header('Expires: Sat, 1 Jan 2000 00:00:00 GMT');
		if (isset($_GET['logout']))
		{
			// Admin interface logout
			setcookie(visitor::$cookie_prefix.'login', '', 0, '/');
			header('Location: '.basename(__FILE__));
			die();
		}
		if (self::$admin_gzip !== 0)
		{
			ini_set('zlib.output_compression_level', self::$admin_gzip);
			if (extension_loaded('zlib') && ini_get('zlib.output_compression') == 0
				&& ini_get('output_handler') != 'ob_gzhandler')
			ob_start('ob_gzhandler');
		}
		$day = isset($_GET['day']) ? $_GET['day'] : 0;
		$login_ok = false;
		if(isset($_POST['password']))
		{
			$md5_password = md5($_POST['password'].$_SERVER['REMOTE_ADDR']);
			$login_ok = $md5_password === md5(self::$admin_password.$_SERVER['REMOTE_ADDR']);
			if ($login_ok)
				setcookie(visitor::$cookie_prefix.'login', $md5_password, 0x7FFFFFFF, '/');
		}
		else
		{
			$md5_password = isset($_COOKIE[visitor::$cookie_prefix.'login']) ? $_COOKIE[visitor::$cookie_prefix.'login'] : '';
			$login_ok = $md5_password === md5(self::$admin_password.$_SERVER['REMOTE_ADDR']);
		}
		self::show_admin_page($login_ok, $day);
		die();
	}

	static function date_holiday($day)
	{
		$today = gmdate('U')+visitor::$db_gmt*60-$day*60*60*24;
		return (gmdate('w', $today) == 0) or (gmdate('w', $today) == 6);
	}
	
	static function header($day)
	{
		$r = '<header><div id="menu">';
		// Calc max
		$max = 0;
		for ($i = -8; $i<=8; $i++)
		{
			if ($day-$i >= 0)
			{
				$file = visitor::db_full_dir().visitor::$file_name_prefix.visitor::date_name($day-$i).'.html';			
				$size = 0;
				if (is_file($file))
					$size = filesize($file);
				if ($size > $max)
					$max = $size;
			}
		}
		// Items
		for ($i = -8; $i<=8; $i++)
		{
			if ($day-$i >= 0)
			{
				$file = visitor::db_full_dir().visitor::$file_name_prefix.visitor::date_name($day-$i).'.html';
				$size = 0;
				if (is_file($file))
					$size = floor((filesize($file) / $max)*50);
				$r .= '<div class="day"><div class="';
				if ($day-$i == 0)
					$r .= 'bar this-day" ';
				else if (self::date_holiday($day-$i))	
					$r .= 'bar holiday" ';
				else	
					$r .= 'bar" ';
				$r .= 'style="border-top-width:'.$size.'px; margin-top:'.(50-$size).'px">';
				if ($i == 0)
					$r .= visitor::date_name($day-$i);
				else
					$r .= '<a href="?day='.($day-$i).'">'.visitor::date_name($day-$i).'</a>';
				$r .= '</div></div>'."\n";
			}
		}
		$r.= '<div class="logout"><a href="?logout">Logout</a></div></div>'."\n";
		return $r."</header>\n";
	}

	private static function show_admin_page($login_ok, $day)
	{
		$file_name = visitor::$file_name_prefix.visitor::date_name($day).'.html';
?><!DOCTYPE html>
<html lang="en"><head><meta charset="utf-8">
<title>Visitor - <?=visitor::date_name($day)?></title>
<!--[if lt IE 9]><script src="http://ie7-js.googlecode.com/svn/version/2.1(beta4)/IE9.js"></script><![endif]-->
<style type="text/css">
html, body { margin: 0; padding: 0; }
html { width: 100%; height: 100%; font-size: 100%; overflow-y: scroll; }
article, aside, details, figcaption, figure, footer, header, hgroup, nav, section { display: block; margin: 0; padding: 0; }
body { white-space: nowrap; color: #303030; }
body { font-size: 11px; line-height: 15px; font-family: verdana;  }
article.login { margin: 10px; }
footer { padding: 2px; overflow: hidden; margin: 10px 8px; color: #808080; }
a:link { color: #0000ff; text-decoration: underline; }
a:visited { color: #505050; text-decoration: underline; }
a:link:hover, a:visited:hover { text-decoration: none; }
<?
		if (!$login_ok)
		{
?></style></head>
<body>
<article class="login">
<form action="?day=0" method="post"><input type="password" name="password">
<input type="submit" value="Login"></form>
</article>
<footer><a href="http://atrise.com/php/visitor/">Atrise Visitor <?=visitor::$version?></a>
<p>*** This is a nonregistered trial version. Not for production use! ***</p>
</footer>
</body></html>
<?
			return;
		}
?>
header { padding: 2px; overflow: hidden; margin: 10px 8px; }
#menu { overflow: hidden; }
.day { padding: 1px; float: left; }
.bar { border-color: silver; border-style: solid; border-width: 0px; font-size: 9px; }
.this-day { border-color: green; }
.holiday { border-color: red; }
.logout { padding: 1px; float: right; }

article { display: table-cell; padding-right: 8px; }
p { color: #b0b0b0; border-left: 10px solid transparent; margin: 0; padding: 1px 2px; }

.h0 { background-color: #ffffff; }
.h1 { background-color: #fffff0; }
.h2 { background-color: #fff4f4; }
.h3 { background-color: #f4ffff; }
.h4 { background-color: #f8f8ff; }
.h5 { background-color: #fff6ff; }
.h6 { background-color: #f6fff6; }
.h7 { background-color: #f6f6f6; }

article a { font-weight: bold; }
i { font-style: normal; }
u { text-decoration: none; position: absolute; background: white; color: #909090;
	border: 1px solid #b0b0b0; padding: 2px 3px 3px 3px; }
i>u, s>u { visibility: hidden; }
i:hover>u, s:hover>u { visibility: visible; }
.type { width: 30px; display: inline-block; text-align: right; margin-right: 4px; }
a.type { color: #b0b0b0; text-decoration: none; font-weight: normal; }
b { color: black; font-weight: normal; }
.e { color: green; font-weight: bold; }
.e404 { color: red; }
.bot { color: orange; }
s { text-decoration: none; margin-left: 8px; }

</style>
</head>
<body>
<?=self::header($day);?>

<article>
<?
		$log_file = visitor::db_full_dir().$file_name;
		if (!file_exists($log_file))
			echo '<p>No records found</p>';
		else
			@include($log_file);
?></article>
<footer>*** This is a nonregistered trial version. Not for production use! The registered version has more features. ***</footer>
</body></html>
<?
	}
	
}?>