<?php new visitor(); class visitor { static $version = '2.2.0.beta';
/*===========================================================================
Visitor info and logging script for PHP 5+.
© Andrew Revvo, 2012, http://atrise.com/php/visitor/
License: http://atrise.com/we/license/
=============================================================================
// Your page code:
<script type="text/javascript" src="/site/visitor.js"></script>
<noscript><img src="/site/visitor.php" alt=""></noscript>

// Your PHP code:
visitor::event(); - for regular pages
visitor::event('404', {$js}, {$screen}, {$gmt}); - for special events
visitor::write_event();

=============================================================================*/
// Settings

	// Relative path to the writable directory
	static $db_dir = '/db/';

	// Database GMT offset in minutes;
	static $db_gmt = 240;

	// Automatically delete old data, days
	static $delete_after_days = '90';
	
	// Allow resolve IP. Disable it to speed-up host
	static $allow_resolve_ip = true;
	
	// Writable file name prefix
	static $file_name_prefix='vis-';

	// Some countries may require a special terms to use cookies (EU Cookie Law).
	// Visit http://www.onlinemarketingacademy.uk.com/eu-cookie-law/ for details.
	// You must change this value to false to fully disable cookie-based statistics.
	static $enable_cookies = true;
	
	// A cookie name prefix
	static $cookie_prefix = 'vis-';
	
	// A filter for title text
	static function filter_title($page, $title)
	{
		if (strpos($page, 'id=') !== false)
			return $title;
		else
			return '';
	}
	
/*===========================================================================*/
// Parameters. Not escaped.

	static $event = ''; // '', '404', or custom
	static $hash = '';
	static $type = 'n'; // f-first, s-session, n-normal

	static $time = ''; // ''-unknown, integer
	static $ftime = '';
	static $stime = '';
	
	static $gmt = ''; // user timezone offset in minutes or ''
	static $gmt_t = ''; // text
	static $utime = ''; // user local time
	static $uftime = '';
	static $ustime = '';

	static $page = ''; // normalized
	static $fpage = ''; 
	static $spage = '';
	static $ref = ''; // ''-no ref, '?'-unknown ref
	static $fref = '';
	static $sref = '';

	static $js = 'unknown'; // enabled, disabled, unknown
	static $screen = 'unknown'; // screen size (1280x1024) or unknown
	static $title = ''; // document title
	
	static $uagent = ''; // user agent
	static $alang = ''; // accept language
	static $aenc = ''; // accept encoding
	static $proxy = '';
	static $ip = '';
	static $ip_list = ''; // separated by ","
	static $host = '';
	static $host_list = ''; // separated by ","

	static $bot = false;

/*===========================================================================*/
// Code

	function __construct()
	{
		if (realpath($_SERVER['SCRIPT_FILENAME']) == realpath(__FILE__))
			self::dispatch();
	}
	
	static function event($e='', $js='unknown', $screen='unknown', $gmt='', $title='')
	{
		self::$event = $e;
		self::$page = self::normalized_url($_SERVER['REQUEST_URI']);
		self::$ref = self::normalized_url(isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '');
		self::$js = $js;
		self::$screen = $screen;
		self::$gmt = $gmt;
		self::$title = self::filter_title(self::$page, $title);
		self::update_gmt_t();
		self::update_cookies();
		self::update_ip();
	}

	static function normalized_url($url)
	{
		if ($url == '?')
			return '?';
		if ($url == '')
			return '';
		$urlp = parse_url($url);
		if (!isset($urlp['host']))
			return $url;
		$host = $urlp['host'];
		if (isset($urlp['port']))
			$host .= ':'.$urlp['port'];
		$this_host = $_SERVER['HTTP_HOST'];
		if (isset($_SERVER['SERVER_PORT']) and ($_SERVER['SERVER_PORT'] !== '80'))
			$this_host .= ':'.$_SERVER['SERVER_PORT'];
		if($host != $this_host)
			return $url;
		$r = $urlp['path'];
		if (isset($urlp['query']))
			$r .= '?'.$urlp['query'];
		return $r;
	}

	static function visible_link($title, $url=null, $url_orig=null)
	{
		$title = htmlspecialchars(stripcslashes(rawurldecode($title)));
		if ($url === null)
			return $title;
		$url = strtr(htmlspecialchars($url), ' ', '+');
		if ($url_orig !== null)
			$url_orig = strtr(htmlspecialchars($url_orig), ' ', '+');
		if ($url_orig !== null) 
			return '<a href="'.$url.'">'.$title.'</a> <a href="'.$url_orig.'">(orig)</a>';
		else
			return '<a href="'.$url.'">'.$title.'</a>';
	}
	
	static function special_url($url)
	{
		//Debug:
		//$url = strtr($url, 'qqq=', '========================');
		// General
		if ($url == '?')
			return '?';
		if ($url == '')
			return '';
		// Local URL
		if ($url{0} == '/')
		{
			//$pos = strpos($url, '?');
			//parse_str(substr($url, $pos+1), $query);
			return self::visible_link($url, null);
		}
		// URL parts
		$urlp = parse_url($url);
		$scheme = isset($urlp['scheme']) ? $urlp['scheme'] : '';
		$host = isset($urlp['host']) ? $urlp['host'] : '';
		$path = isset($urlp['path']) ? $urlp['path'] : '';
		$query = isset($urlp['query']) ? $urlp['query'] : '';
		parse_str($query, $query);
		// Google translate: translate.googleusercontent, translate.google.
		if (strpos($host, 'translate.google') !== false)
		{
			// Translate
			$p = self::normalized_url($query['u']);
			return self::visible_link('google translate '.$query['langpair'].' '.$p, null);
		}
		// Google search
		if (strpos($host, 'google.') !== false)
		{
			// Images
			if (strpos($path, '/imgres') === 0)
			{
				$img = self::normalized_url($query['imgurl']);
				return self::visible_link('google img → '.$img, $url);
			}
			// Search
			$title = 'google → ';
			if (strlen($query['q']) == 0)
				return self::visible_link('google', $scheme.'://'.$host.'/', $url);
			else
				return self::visible_link('google → '.$query['q'], $scheme.'://'.$host.'/search?q='.$query['q'], $url);
		}
		// international SE
		$se_url = array(
			'bing.' => 'bing|q'
		);
		foreach ($se_url as $substring => $v)
		{
			if (strpos($host, $substring) !== false)
			{
				$ex = explode('|', $v);
				return self::visible_link($ex[0].' → '.$query[$ex[1]], $url);
			}
		}
		// russian SE
		$se_url = array(
			'yandex.' => 'yandex|text',
			'rambler.' => 'rambler|query',
			'go.mail.ru' => 'go.mail.ru|q'
		);
		foreach ($se_url as $substring => $v)
		{
			if (strpos($host, $substring) !== false)
			{
				$ex = explode('|', $v);
				$keys = $query[$ex[1]];
				// win1251 check
				if (strpos($keys, '%E') !== false)
					$keys = iconv('windows-1251', 'utf-8', rawurldecode($keys));
				else if ((strpos($keys, chr(0xe0)) !== false)
					or (strpos($keys, chr(0xee)) !== false)
					or (strpos($keys, chr(0xe5)) !== false))
					$keys = iconv('windows-1251', 'utf-8', $keys);
				return self::visible_link($ex[0].' → '.$keys, $url);
			}
		}
		// MS Translator
		if (strpos($path, '/bvsandbox.aspx') === 0)
		{
			$p = self::normalized_url($query['a']);
			return self::visible_link('ms translate '.$query['to'].' '.$p, null);
		}
		else if (strpos($path, '/proxy.ashx') === 0)
		{
			$p = self::normalized_url($query['a']);
			return self::visible_link('ms translated '.$p, null);
		}
		// Online Translator (Promt)
		if (strpos($host, 'online-translator.') !== false)
		{
			if (strpos(strtolower($path), '/site_translation.aspx') === 0)
				return self::visible_link('promt translate '.$query['prmtlang'], null);
			else if (strpos(strtolower($path), '/translation.aspx') !== false)
			{
				$p = self::normalized_url($query['sourceURL']);
				return self::visible_link('promt translated '.$p, null);
			}
		}
		// Else all cases
		return self::visible_link($link, $link);
	}

	static function special_event($e)
	{
		if ($e == '')
			return '';
		$class = '';
		if ($e == '404')
			$class = ' e404';
		return '<i class="e'.$class.'">'.htmlspecialchars($e).'</i>';
	}

	static function special_host()
	{
		$proxy_t = (self::$proxy != '') ? ' via proxy: '.htmlspecialchars(self::$proxy) : '';
		$ip_t = (self::$ip_list != self::$host_list) ? '<u>'.self::$ip_list.'</u>' : '';
		$host_t = '<i>'.self::$host_list.$proxy_t.$ip_t.'</i>';
		return $host_t;
	}

	static function fpage_info()
	{
		if (self::$fpage == self::$spage)
			return '';
		$t = (self::$ftime != '') ? gmdate('Y-m-d H:i', self::$ftime+self::$db_gmt*60) : '';
		$t .= '<i class="type">∞ →</i>';
		$ref_t = self::special_url(self::$fref);
		$t .= $ref_t;
		$page_t = self::special_url(self::$fpage);
		if (($ref_t != '') and ($page_t != ''))
			$t .= ' → ';
		if ($page_t != '')
			$t .= '<b>'.$page_t.'</b>';
		$uftime_t = (self::$uftime != '') ? ' '.gmdate('H:i', self::$uftime).self::$gmt_t : '';
		if (($t != '') and ($uftime_t != ''))
			$t .= ' ';
		$t .= $uftime_t;
		return $t;
	}
	
	static function spage_info()
	{
		if (self::$spage == self::$page)
			return '';
		$t = (self::$stime != '') ? gmdate('Y-m-d H:i', self::$stime+self::$db_gmt*60) : '';
		$t .= '<i class="type">● →</i>';
		$ref_t = self::special_url(self::$sref);
		$t .= $ref_t;
		$page_t = self::special_url(self::$spage);
		if (($ref_t != '') and ($page_t != ''))
			$t .= ' → ';
		if ($page_t != '')
			$t .= '<b>'.$page_t.'</b>';
		$ustime_t = (self::$ustime != '') ? ' '.gmdate('H:i', self::$ustime).self::$gmt_t : '';
		if (($t != '') and ($ustime_t != ''))
			$t .= ' ';
		$t .= $ustime_t;
		return $t;
	}

	static function fpage_info_text()
	{
		if (self::$fpage == self::$spage)
			return '';
		$t = (self::$ftime != '') ? gmdate('Y-m-d H:i', self::$ftime+self::$db_gmt*60) : '';
		if (($t != '') and (self::$fref != ''))
			$t .= ' | ';
		if (self::$fref != '')
			$t .= htmlspecialchars(rawurldecode(self::$fref));
		else
			$t .= ' |';
		if (($t != '') and (self::$fpage != ''))
			$t .= ' → ';
		if (self::$fpage != '')
			$t .= htmlspecialchars(rawurldecode(self::$fpage));
		$uftime_t = (self::$uftime != '') ? gmdate('H:i', self::$uftime).self::$gmt_t : '';
		if (($t != '') and ($uftime_t != ''))
			$t .= ' | ';
		if ($uftime_t != '')
			$t .= $uаtime_t;
		return $t;
	}
	
	static function spage_info_text()
	{
		if (self::$spage == self::$page)
			return '';
		$t = (self::$stime != '') ? gmdate('Y-m-d H:i', self::$stime+self::$db_gmt*60) : '';
		if (($t != '') and (self::$sref != ''))
			$t .= ' | ';
		if (self::$sref != '')
			$t .= htmlspecialchars(rawurldecode(self::$sref));
		else
			$t .= ' |';
		if (($t != '') and (self::$spage != ''))
			$t .= ' → ';
		if (self::$spage != '')
			$t .= htmlspecialchars(rawurldecode(self::$spage));
		$ustime_t = (self::$ustime != '') ? gmdate('H:i', self::$ustime).self::$gmt_t : '';
		if (($t != '') and ($ustime_t != ''))
			$t .= ' | ';
		if ($ustime_t != '')
			$t .= $ustime_t;
		return $t;
	}
	
	static function ext_info()
	{
		$t = htmlspecialchars(self::$uagent);
		if (($t != '') and (self::$aenc != ''))
			$t .= ' | ';
		$t .= htmlspecialchars(self::$aenc);
		$fpage = self::fpage_info();
		if (($t != '') and ($fpage != ''))
			$t .= '<br>';
		$t .= $fpage;
		$spage = self::spage_info();
		if (($t != '') and ($spage != ''))
			$t .= '<br>';
		$t .= $spage;
		return $t;
	}

	static function write_event()
	{
		// Time
		$time = gmdate('H:i', self::$time+self::$db_gmt*60);
		$u = self::ext_info();
		if ($u != '')
			$u = '<u>'.$u.'</u>';
		$time_t = '<i class="time">'.$time.$u.'</i>';
		
		// Type
		$type_t = '<a class="type" href="#'.self::$hash.'">';
		if (self::$type == 's')
			$type_t .= '● →';
		else if (self::$type == 'f')
			$type_t .= '∞ →';
		else
			$type_t .= ' '; // nbsp!
		$type_t .= '</a>';
		
		// Ref, Page, Title, Event
		$ref_t = self::special_url(self::$ref);
		$page_t = self::special_url(self::$page);
		$title_t = htmlspecialchars(self::$title);
		if ($title_t != '')
			$title_t = ' = <b>'.$title_t.'</b>';
		if ($page_t != '')
			$page_t = '<b>'.$page_t.'</b>';
		$event_t = self::special_event(self::$event);
		$rpe_t = $ref_t;
		if (($rpe_t != '') and ($page_t != ''))
			$rpe_t .= ' → ';
		if ($page_t != '')
			$rpe_t .= $page_t;
		if ($title_t != '')
			$rpe_t .= $title_t;
		if (($rpe_t != '') and ($event_t != ''))
			$rpe_t .= ' → ';
		if ($event_t != '')
			$rpe_t .= $event_t;

		// Info
		$bot_t = (self::$bot != '') ? '<i class="bot">bot</i>' : '';
		$i_t = $bot_t;
		$host_t = self::special_host();
		if ($host_t != '')
			$i_t .= ' '.$host_t;
		$screen_t = (self::$screen != 'unknown') ? htmlspecialchars(self::$screen) : '';
		if (self::$alang != '')
			$i_t .= ' '.htmlspecialchars(self::$alang);
		if ($screen_t != '')
			$i_t .= ' '.$screen_t;
		if (self::$gmt_t != '')
			$i_t .= ' '.gmdate('H:i', self::$utime).self::$gmt_t;
		$i_t = '<s>'.$i_t.'</s>';
		
		// Record line
		$class = 'h'.chr(0x30 + (abs(crc32(self::$ip)) % 7)); //0x30='0'
		$t = '<p data-id="'.self::$hash.'" class="'.$class.'">'.$time_t.$type_t.$rpe_t.$i_t."</p>\n";
		// Write
		$file = self::$file_name_prefix.self::date_name(0).'.html';
		$file_del = self::$file_name_prefix.self::date_name(self::$delete_after_days).'.html';
		if (file_exists($file_del))
			@unlink($file_del);
		return self::safe_write($file, $t, 'a');
	}

	static function update_gmt_t()
	{
		if (self::$gmt != '')
		{
			$v = round(self::$gmt/60, 1);
			if ($v >= 0)
				self::$gmt_t = ' GMT+'.$v;
			else
				self::$gmt_t =' GMT'.$v;
		}
	}

	static function update_cookies()
	{
		if (!self::$enable_cookies)
			return;
		self::$time = gmdate('U');
		if (self::$gmt !== '')
			self::$utime = self::$time+self::$gmt*60;
		if (!isset($_COOKIE[self::$cookie_prefix.'fpag']))
		{
			// The first site enter
			self::$type = 'f';
			self::$ftime = self::$time;
			self::$uftime = self::$utime;
			setcookie(self::$cookie_prefix.'ftim', self::$ftime, 0x7FFFFFFF, '/');
			self::$fpage = self::$page;
			setcookie(self::$cookie_prefix.'fpag', self::$fpage, 0x7FFFFFFF, '/');
			self::$fref = self::$ref;
			setcookie(self::$cookie_prefix.'fref', self::$fref, 0x7FFFFFFF, '/');
			self::$stime = self::$time;
			self::$ustime = self::$utime;
			setcookie(self::$cookie_prefix.'stim', self::$stime, 0, '/');
			self::$spage = self::$page;
			setcookie(self::$cookie_prefix.'spag', self::$spage, 0, '/');
			self::$sref = self::$ref;
			setcookie(self::$cookie_prefix.'sref', self::$sref, 0, '/');
			return;
		}
		self::$ftime = isset($_COOKIE[self::$cookie_prefix.'ftim']) ? $_COOKIE[self::$cookie_prefix.'ftim'] : '';
		if ((self::$gmt != '') and (self::$ftime != ''))
			self::$uftime = self::$ftime+self::$gmt*60;
		self::$fpage = isset($_COOKIE[self::$cookie_prefix.'fpag']) ? $_COOKIE[self::$cookie_prefix.'fpag'] : '';
		self::$fref = isset($_COOKIE[self::$cookie_prefix.'fref']) ? $_COOKIE[self::$cookie_prefix.'fref'] : '';
		if (!isset($_COOKIE[self::$cookie_prefix.'spag']))
		{
			// Returned visit enter
			self::$type = 's';
			self::$stime = self::$time;
			self::$ustime = self::$utime;
			setcookie(self::$cookie_prefix.'stim', self::$stime, 0, '/');
			self::$spage = self::$page;
			setcookie(self::$cookie_prefix.'spag', self::$spage, 0, '/');
			self::$sref = self::$ref;
			setcookie(self::$cookie_prefix.'sref', self::$sref, 0, '/');
		}
		else
		{
			// Normal visit enter
			self::$type = 'n';		
			self::$stime = isset($_COOKIE[self::$cookie_prefix.'stim']) ? $_COOKIE[self::$cookie_prefix.'stim'] : '';
			if ((self::$gmt != '') and (self::$stime != ''))
				self::$ustime = self::$stime+self::$gmt*60;
			self::$spage = isset($_COOKIE[self::$cookie_prefix.'spag']) ? $_COOKIE[self::$cookie_prefix.'spag'] : '';
			self::$sref = isset($_COOKIE[self::$cookie_prefix.'sref']) ? $_COOKIE[self::$cookie_prefix.'sref'] : '';
		}
	}

	static function is_bot($uagent, $alang, $aenc)
	{
		if (($uagent == '') and ($aenc == ''))
			return true;
		if (($alang == 'en') and ($aenc == ''))
			return true;
		if (strlen($uagent) <= 12)
			return true;
		if ($aenc == 'identity')
			return true;
		$bots = array('bot/','Bot/','pider/','Slurp/','RusURL/','PycURL/','libwww-perl/','http://',
			'BingPreview/','Googlebot','Ezooms/','Morning Paper','Mediapartners-Google','Commons-HttpClient/','Python-urllib/','SoftSearch.ru robot','Java/','Processor/','Ocelli/','Wget/','Winder/','Fucking');
		foreach ($bots as $i)
			if (strpos($uagent, $i) !== false)
				return true;
		return false;
	}

	static function update_ip()
	{
		self::$uagent = $_SERVER['HTTP_USER_AGENT'];
		self::$alang = $_SERVER['HTTP_ACCEPT_LANGUAGE'];
		self::$aenc = $_SERVER['HTTP_ACCEPT_ENCODING'];
		
		//Debug
		//$_SERVER['REMOTE_ADDR'] = '84.52.90.226';
		//$_SERVER['HTTP_X_REAL_IP'] = '127.0.0.2';
		//$_SERVER['HTTP_X_FORWARDED_FOR'] = '192.168.1.1, 44.69.125.74';
		//$_SERVER['HTTP_X_FORWARDED_FOR'] = '44.69.125.74';

		$ip_list = $_SERVER['REMOTE_ADDR'];
		if (isset($_SERVER['HTTP_CLIENT_IP']))
		{
			if (strpos($ip_list, $_SERVER['HTTP_CLIENT_IP']) === false)
				$ip_list = $_SERVER['HTTP_CLIENT_IP'].','.$ip_list;
		}
		if (isset($_SERVER['HTTP_X_REAL_IP']))
		{
			if (strpos($ip_list, $_SERVER['HTTP_X_REAL_IP']) === false)
				$ip_list = $_SERVER['HTTP_X_REAL_IP'].','.$ip_list;
		}
		if (isset($_SERVER['HTTP_X_FORWARDED_FOR']))
		{
			// X-Forwarded-For: client1, proxy1, proxy2
			// ",_"-separated list of IP addresses
			$xf = array_reverse(explode(',', $_SERVER['HTTP_X_FORWARDED_FOR']));
			foreach ($xf as $i)
			{
				$ip_corr = trim($i);
				if (strpos($ip_list, $ip_corr) === false)
					$ip_list = $ip_corr.','.$ip_list;
			}
		}
		if (isset($_SERVER['HTTP_VIA']))
			self::$proxy = $_SERVER['HTTP_VIA'];
		self::$ip = $_SERVER['REMOTE_ADDR'];
		self::$ip_list = $ip_list;
		$host_list = '';
		foreach (explode(',', $ip_list) as $i)
		{
			if ($host_list != '')
				$host_list .= ',';
			self::$host = self::$allow_resolve_ip ? gethostbyaddr($i) : $i;
			$host_list .= self::$host;
		}
		self::$host_list = $host_list;
		self::$hash = substr(md5(self::$ip_list.self::$uagent.self::$alang),-8);
		self::$bot = self::is_bot(self::$uagent, self::$alang, self::$aenc);
	}

	static function img_event()
	{
		self::$page = self::normalized_url(isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '?');
		self::$ref = '?';
		self::$js = 'disabled';
		self::$screen = 'unknown';
		self::$gmt = '';
		self::$title = '';
		self::update_cookies();
		self::update_ip();
	}

	static function js_event()
	{
		self::$page = self::normalized_url(isset($_GET['p']) ? $_GET['p'] : '?');
		self::$ref = self::normalized_url(isset($_GET['r']) ? $_GET['r'] : '?');
		self::$js = 'enabled';
		self::$screen = self::normalized_url(isset($_GET['s']) ? $_GET['s'] : 'unknown');
		self::$event = self::normalized_url(isset($_GET['e']) ? $_GET['e'] : '');
		self::$gmt = self::normalized_url(isset($_GET['gmt']) ? $_GET['gmt'] : '');
		self::$title = self::filter_title(self::$page, isset($_GET['t']) ? $_GET['t'] : '');
		self::update_gmt_t();
		self::update_cookies();
		self::update_ip();
	}
	
	static function dispatch()
	{
		header('Cache-Control: no-cache, must-revalidate');
		header('Expires: Sat, 1 Jan 2000 00:00:00 GMT');
		if (isset($_GET['gmt']))
		{
			// Jscript is enabled. Returns nothing, because from AJAX
			self::js_event();
		}
		else
		{
			// Jscript is disabled. Returns an 1x1 transparent gif
			header('Content-Type: image/gif');
			self::img_event();
			echo base64_decode('R0lGODlhAQABAIAAAAAAAAAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==');
		}
		self::write_event();
		die();
	}

	static function date_name($day)
	{
		return gmdate('Y-m-d', gmdate('U')+self::$db_gmt*60-$day*60*60*24);
	}	

	static function db_full_dir()
	{
		return dirname(realpath(__FILE__)).self::$db_dir;
	}	
	
	static function safe_write($path, $data, $mode='a')
	{
		$fp = fopen(self::db_full_dir().$path, $mode);
		if (!$fp)
			return false;
		$retries = 0;
		$max_retries = 100;
		while (!flock($fp, LOCK_EX))
		{
			usleep(rand(1, 10000));
			$retries += 1;
			if ($retries == $max_retries)
			{
				fclose($fp);
				return false;
			}
		}
		fwrite($fp, $data);
		flock($fp, LOCK_UN);
		fclose($fp);
		return true; 
	}	

} ?>